      SUBROUTINE WRITENOUT
c     =============================================
c     writes the SDDS page to disk
c     ---------------------------------------------
c
      include 'genesis.def'
      include 'io.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i
c
      if (ftype.eq.f_sdds) then
         if (SDDSNOUTPAGESTARTED .eq. 1) then
            i = SDDS_WritePage_F(2)
            if (i .NE. 1) then
               call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
               stop 1
            end if
            SDDSNOUTPAGESTARTED = 0
         endif
      endif
c
      RETURN
      END

      SUBROUTINE DEFINESDDSPARAMETERS(FILEINDEX)
c     =============================================
c     define common sdds parameters
c     ---------------------------------------------
c
      include 'genesis.def'
      include 'input.cmn'
      include 'particle.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i, j, fileindex
      CHARACTER*30 pname
      DIMENSION pNamesS(2)
      CHARACTER*30 pNamesS
      DIMENSION pValuesS(2)
      CHARACTER*30 pValuesS
      DIMENSION pNamesD(99)
      CHARACTER*30 pNamesD
      DIMENSION pValuesD(99)
      REAL*8 pValuesD
      DIMENSION pNamesL(70)
      CHARACTER*30 pNamesL
      DIMENSION pValuesL(70)
      INTEGER pValuesL
c
      pNamesS(1) = "InputFile"
      pValuesS(1) = inputfile
      pNamesS(2) = "OutputFile"
      pValuesS(2) = outputfile
      
      pNamesD(1) = "AW0"
      pValuesD(1) = AW0
      pNamesD(2) = "XKX"
      pValuesD(2) = XKX
      pNamesD(3) = "XKY"
      pValuesD(3) = XKY
      pNamesD(4) = "WCOEFZ_1"
      pValuesD(4) = WCOEFZ(1)
      pNamesD(5) = "WCOEFZ_2"
      pValuesD(5) = WCOEFZ(2)
      pNamesD(6) = "WCOEFZ_3"
      pValuesD(6) = WCOEFZ(3)
      pNamesD(7) = "XLAMD"
      pValuesD(7) = XLAMD
      pNamesD(8) = "FBESS0"
      pValuesD(8) = FBESS0
      pNamesD(9) = "DELAW"
      pValuesD(9) = DELAW
      pNamesD(10) = "AWD"
      pValuesD(10) = AWD
      pNamesD(11) = "GAMMA0"
      pValuesD(11) = GAMMA0
      pNamesD(12) = "DELGAM"
      pValuesD(12) = DELGAM
      pNamesD(13) = "RXBEAM"
      pValuesD(13) = RXBEAM
      pNamesD(14) = "RYBEAM"
      pValuesD(14) = RYBEAM
      pNamesD(15) = "ALPHAX"
      pValuesD(15) = ALPHAX
      pNamesD(16) = "ALPHAY"
      pValuesD(16) = ALPHAY
      pNamesD(17) = "EMITX"
      pValuesD(17) = EMITX
      pNamesD(18) = "EMITY"
      pValuesD(18) = EMITY
      pNamesD(19) = "XBEAM"
      pValuesD(19) = XBEAM
      pNamesD(20) = "YBEAM"
      pValuesD(20) = YBEAM
      pNamesD(21) = "PXBEAM"
      pValuesD(21) = PXBEAM
      pNamesD(22) = "PYBEAM"
      pValuesD(22) = PYBEAM
      pNamesD(23) = "XLAMDS"
      pValuesD(23) = XLAMDS
      pNamesD(24) = "PRAD0"
      pValuesD(24) = PRAD0
      pNamesD(25) = "ZRAYL"
      pValuesD(25) = ZRAYL
      pNamesD(26) = "ZWAIST"
      pValuesD(26) = ZWAIST
      pNamesD(27) = "RMAX0"
      pValuesD(27) = RMAX0
      pNamesD(28) = "ZSEP"
      pValuesD(28) = ZSEP
      pNamesD(29) = "DELZ"
      pValuesD(29) = DELZ
      pNamesD(30) = "ZSTOP"
      pValuesD(30) = ZSTOP
      pNamesD(31) = "QUADF"
      pValuesD(31) = QUADF
      pNamesD(32) = "QUADD"
      pValuesD(32) = QUADD
      pNamesD(33) = "FL"
      pValuesD(33) = FL
      pNamesD(34) = "DL"
      pValuesD(34) = DL
      pNamesD(35) = "DRL"
      pValuesD(35) = DRL
      pNamesD(36) = "F1ST"
      pValuesD(36) = F1ST
      pNamesD(37) = "QFDX"
      pValuesD(37) = QFDX
      pNamesD(38) = "QFDY"
      pValuesD(38) = QFDY
      pNamesD(39) = "CURPEAK"
      pValuesD(39) = CURPEAK
      pNamesD(40) = "CURLEN"
      pValuesD(40) = CURLEN
      pNamesD(41) = "SHOTNOISE"
      pValuesD(41) = SHOTNOISE
      pNamesD(42) = "SVAR"
      pValuesD(42) = SVAR
      pNamesD(43) = "DGRID"
      pValuesD(43) = DGRID
      pNamesD(44) = "SOLEN"
      pValuesD(44) = SOLEN
      pNamesD(45) = "SL"
      pValuesD(45) = SL
      pNamesD(46) = "CUTTAIL"
      pValuesD(46) = CUTTAIL
      pNamesD(47) = "ELOSS"
      pValuesD(47) = ELOSS
      pNamesD(48) = "VERSION"
      pValuesD(48) = VERSION
      pNamesD(49) = "AWX"
      pValuesD(49) = AWX
      pNamesD(50) = "AWY"
      pValuesD(50) = AWY
      pNamesD(51) = "CONDITX"
      pValuesD(51) = CONDITX
      pNamesD(52) = "CONDITY"
      pValuesD(52) = CONDITY
      pNamesD(53) = "BUNCH"
      pValuesD(53) = BUNCH
      pNamesD(54) = "BUNCHPHASE"
      pValuesD(54) = BUNCHPHASE
      pNamesD(55) = "EMOD"
      pValuesD(55) = EMOD
      pNamesD(56) = "EMODPHASE"
      pValuesD(56) = EMODPHASE
      pNamesD(57) = "PRADH0"
      pValuesD(57) = PRADH0
      pNamesD(58) = "IBFIELD"
      pValuesD(58) = IBFIELD
      pNamesD(59) = "IMAGL"
      pValuesD(59) = IMAGL
      pNamesD(60) = "IDRIL"
      pValuesD(60) = IDRIL
      pNamesD(61) = "IGAMREF"
      pValuesD(61) = IGAMREF
      pNamesD(62) = "RMAX0SC"
      pValuesD(62) = RMAX0SC
      pNamesD(63) = "ITRAM11"
      pValuesD(63) = ITRAM11
      pNamesD(64) = "ITRAM12"
      pValuesD(64) = ITRAM12
      pNamesD(65) = "ITRAM13"
      pValuesD(65) = ITRAM13
      pNamesD(66) = "ITRAM14"
      pValuesD(66) = ITRAM14
      pNamesD(67) = "ITRAM15"
      pValuesD(67) = ITRAM15
      pNamesD(68) = "ITRAM16"
      pValuesD(68) = ITRAM16
      pNamesD(69) = "ITRAM21"
      pValuesD(69) = ITRAM21
      pNamesD(70) = "ITRAM22"
      pValuesD(70) = ITRAM22
      pNamesD(71) = "ITRAM23"
      pValuesD(71) = ITRAM23
      pNamesD(72) = "ITRAM24"
      pValuesD(72) = ITRAM24
      pNamesD(73) = "ITRAM25"
      pValuesD(73) = ITRAM25
      pNamesD(74) = "ITRAM26"
      pValuesD(74) = ITRAM26
      pNamesD(75) = "ITRAM31"
      pValuesD(75) = ITRAM31
      pNamesD(76) = "ITRAM32"
      pValuesD(76) = ITRAM32
      pNamesD(77) = "ITRAM33"
      pValuesD(77) = ITRAM33
      pNamesD(78) = "ITRAM34"
      pValuesD(78) = ITRAM34
      pNamesD(79) = "ITRAM35"
      pValuesD(79) = ITRAM35
      pNamesD(80) = "ITRAM36"
      pValuesD(80) = ITRAM36
      pNamesD(81) = "ITRAM41"
      pValuesD(81) = ITRAM41
      pNamesD(82) = "ITRAM42"
      pValuesD(82) = ITRAM42
      pNamesD(83) = "ITRAM43"
      pValuesD(83) = ITRAM43
      pNamesD(84) = "ITRAM44"
      pValuesD(84) = ITRAM44
      pNamesD(85) = "ITRAM45"
      pValuesD(85) = ITRAM45
      pNamesD(86) = "ITRAM46"
      pValuesD(86) = ITRAM46
      pNamesD(87) = "ITRAM51"
      pValuesD(87) = ITRAM51
      pNamesD(88) = "ITRAM52"
      pValuesD(88) = ITRAM52
      pNamesD(89) = "ITRAM53"
      pValuesD(89) = ITRAM53
      pNamesD(90) = "ITRAM54"
      pValuesD(90) = ITRAM54
      pNamesD(91) = "ITRAM55"
      pValuesD(91) = ITRAM55
      pNamesD(92) = "ITRAM56"
      pValuesD(92) = ITRAM56
      pNamesD(93) = "ITRAM61"
      pValuesD(93) = ITRAM61
      pNamesD(94) = "ITRAM62"
      pValuesD(94) = ITRAM62
      pNamesD(95) = "ITRAM63"
      pValuesD(95) = ITRAM63
      pNamesD(96) = "ITRAM64"
      pValuesD(96) = ITRAM64
      pNamesD(97) = "ITRAM65"
      pValuesD(97) = ITRAM65
      pNamesD(98) = "ITRAM66"
      pValuesD(98) = ITRAM66
      pNamesD(99) = "CHARGE"
      pValuesD(99) = CHARGE
c     
      pNamesL(1) = "IERTYP"
      pValuesL(1) = IERTYP
      pNamesL(2) = "IWITYP"
      pValuesL(2) = IWITYP
      pNamesL(3) = "ISEED"
      pValuesL(3) = ISEED
      pNamesL(4) = "NPART"
      pValuesL(4) = NPART
      pNamesL(5) = "NCAR"
      pValuesL(5) = NCAR
      pNamesL(6) = "LBC"
      pValuesL(6) = LBC
      pNamesL(7) = "NSCR"
      pValuesL(7) = NSCR
      pNamesL(8) = "NSCZ"
      pValuesL(8) = NSCZ
      pNamesL(9) = "NPTR"
      pValuesL(9) = NPTR
      pNamesL(10) = "NWIG"
      pValuesL(10) = NWIG
      pNamesL(11) = "NSEC"
      pValuesL(11) = NSEC
      pNamesL(12) = "IORB"
      pValuesL(12) = IORB
      pNamesL(13) = "MAGIN"
      pValuesL(13) = MAGIN
      pNamesL(14) = "MAGOUT"
      pValuesL(14) = MAGOUT
      pNamesL(15) = "ILDGAM"
      pValuesL(15) = ILDGAM
      pNamesL(16) = "ILDPSI"
      pValuesL(16) = ILDPSI
      pNamesL(17) = "ILDX"
      pValuesL(17) = ILDX
      pNamesL(18) = "ILDY"
      pValuesL(18) = ILDY
      pNamesL(19) = "ILDPX"
      pValuesL(19) = ILDPX
      pNamesL(20) = "ILDPY"
      pValuesL(20) = ILDPY
      pNamesL(21) = "ITGAUS"
      pValuesL(21) = ITGAUS
      pNamesL(22) = "IPHSTY"
      pValuesL(22) = IPHSTY
      pNamesL(23) = "ISHSTY"
      pValuesL(23) = ISHSTY
      pNamesL(24) = "IPPART"
      pValuesL(24) = IPPART
      pNamesL(25) = "ISPART"
      pValuesL(25) = ISPART
      pNamesL(26) = "IPRADI"
      pValuesL(26) = IPRADI
      pNamesL(27) = "ISRADI"
      pValuesL(27) = ISRADI
      pNamesL(28) = "IDUMP"
      pValuesL(28) = IDUMP
      pNamesL(29) = "IOTAIL"
      pValuesL(29) = IOTAIL
      pNamesL(30) = "NTAIL"
      pValuesL(30) = NTAIL
      pNamesL(31) = "NSLICE"
      pValuesL(31) = NSLICE
      pNamesL(32) = "IALL"
      pValuesL(32) = IALL
      pNamesL(33) = "ITDP"
      pValuesL(33) = ITDP
      pNamesL(34) = "IPSEED"
      pValuesL(34) = IPSEED
      pNamesL(35) = "ISCAN"
      pValuesL(35) = ISCAN
      pNamesL(36) = "NSCAN"
      pValuesL(36) = NSCAN
      pNamesL(37) = "NBINS"
      pValuesL(37) = NBINS
      pNamesL(38) = "NHARM"
      pValuesL(38) = NHARM
      pNamesL(39) = "ISRAVG"
      pValuesL(39) = ISRAVG
      pNamesL(40) = "ISRSIG"
      pValuesL(40) = ISRSIG
      pNamesL(41) = "NDCUT"
      pValuesL(41) = NDCUT
      pNamesL(42) = "IDMPFLD"
      pValuesL(42) = IDMPFLD
      pNamesL(43) = "IDMPPAR"
      pValuesL(43) = IDMPPAR
      pNamesL(44) = "ILOG"
      pValuesL(44) = ILOG
      pNamesL(45) = "IGAMGAUS"
      pValuesL(45) = IGAMGAUS
      pNamesL(46) = "INVERFC"
      pValuesL(46) = INVERFC
      pNamesL(47) = "IALLHARM"
      pValuesL(47) = IALLHARM
      pNamesL(48) = "IHARMSC"
      pValuesL(48) = IHARMSC
      pNamesL(49) = "ISNTYP"
      pValuesL(49) = ISNTYP
      pNamesL(50) = "FFSPEC"
      pValuesL(50) = FFSPEC
      pNamesL(51) = "CONVHARM"
      pValuesL(51) = CONVHARM
      pNamesL(52) = "ALIGNRADF"
      pValuesL(52) = ALIGNRADF
      pNamesL(53) = "OFFSETRADF"
      pValuesL(53) = OFFSETRADF
      pNamesL(54) = "MULTCONV"
      pValuesL(54) = MULTCONV
      pNamesL(55) = "ISCRKUP"
      pValuesL(55) = ISCRKUP
      pNamesL(56) = "TRAMA"
      pValuesL(56) = TRAMA
      pNamesL(57) = "LOUT_1"
      pValuesL(57) = LOUT(1)
      pNamesL(58) = "LOUT_2"
      pValuesL(58) = LOUT(2)
      pNamesL(59) = "LOUT_3"
      pValuesL(59) = LOUT(3)
      pNamesL(60) = "LOUT_4"
      pValuesL(60) = LOUT(4)
      pNamesL(61) = "LOUT_5"
      pValuesL(61) = LOUT(5)
      pNamesL(62) = "LOUT_6"
      pValuesL(62) = LOUT(6)
      pNamesL(63) = "LOUT_7"
      pValuesL(63) = LOUT(7)
      pNamesL(64) = "LOUT_8"
      pValuesL(64) = LOUT(8)
      pNamesL(65) = "LOUT_9"
      pValuesL(65) = LOUT(9)
      pNamesL(66) = "LOUT_10"
      pValuesL(66) = LOUT(10)
      pNamesL(67) = "LOUT_11"
      pValuesL(67) = LOUT(11)
      pNamesL(68) = "LOUT_12"
      pValuesL(68) = LOUT(12)
      pNamesL(69) = "LOUT_13"
      pValuesL(69) = LOUT(13)
      pNamesL(70) = "LOUT_14"
      pValuesL(70) = LOUT(14)
c
      do j = 1,2
         i = SDDS_DefineParameter_F(fileindex,pNamesS(j),"","","","",
     +        SDDS_STRING,pValuesS(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j = 1,99
         i = SDDS_DefineParameter1_F(fileindex,pNamesD(j),"","","",
     +        "",SDDS_DOUBLE,pValuesD(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j = 1,70
         i = SDDS_DefineParameter1_F(fileindex,pNamesL(j),"","","",
     +        "",SDDS_LONG,pValuesL(j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      end do
      do j=1,NHMAX
         write(pname,'(I2)') 14+j
         pname = 'LOUT_' // pname
         i = SDDS_DefineParameter1_F(fileindex,pname,"","","","",
     +        SDDS_LONG,LOUT(14+j))
         if (i .LT. 0) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
      enddo

      RETURN
      END
      
      SUBROUTINE OPENFIELDFILE
c     ==================================================================
c     Opens the FIELDFILE
c     ------------------------------------------------------------------

      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      INCLUDE 'io.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i,ierr1
c
      i = SDDS_InitializeInput_F(1,FIELDFILE)
      if (i .NE. 1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      i = SDDS_GetColumnIndex_F(1,'ReA')
      if (i .EQ. -1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      SDDSNFINRealIndex = i
      i = SDDS_GetColumnIndex_F(1,'ImA')
      if (i .EQ. -1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      SDDSNFINImagIndex = i
      
      SDDSNFINCurrentPage = 0
      i = SDDS_GetColumnType_F(1, SDDSNFINRealIndex) 
      if (i .NE. SDDS_DOUBLE) then
         write (6,*) "invalid column type in field file"
         stop 1
      end if
      i = SDDS_GetColumnType_F(1, SDDSNFINImagIndex) 
      if (i .NE. SDDS_DOUBLE) then
         write (6,*) "invalid column type in field file"
         stop 1
      end if
      Return
      End

      SUBROUTINE OPENPARTFILE
c     ==================================================================
c     Opens the PARTFILE
c     ------------------------------------------------------------------

      INCLUDE 'genesis.def'
      INCLUDE 'input.cmn'
      INCLUDE 'io.cmn'
      include 'sdds.cmn'
      INCLUDE "SDDSFortran.h"
c
      INTEGER i,j,ierr1
      DIMENSION cNamesD(6)
      CHARACTER*9 cNamesD
c
      cNamesD(1) = "Energy"
      cNamesD(2) = "Theta"
      cNamesD(3) = "XPosition"
      cNamesD(4) = "YPosition"
      cNamesD(5) = "XMomentum"
      cNamesD(6) = "YMomentum"
c
      i = SDDS_InitializeInput_F(6,PARTFILE)
      if (i .NE. 1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      i = SDDS_GetParameterIndex_F(6,'Slice')
      if (i .EQ. -1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      SDDSNPINSliceIndex = i
      i = SDDS_GetParameterType_F(6, SDDSNPINSliceIndex) 
      if (i .NE. SDDS_LONG) then
         write (6,*) "invalid parameter type in particle file"
         stop 1
      end if
      i = SDDS_GetParameterIndex_F(6,'Current')
      if (i .EQ. -1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      SDDSNPINCurrentIndex = i
      i = SDDS_GetParameterType_F(6, SDDSNPINCurrentIndex) 
      if (i .NE. SDDS_DOUBLE) then
         write (6,*) "invalid parameter type in particle file"
         stop 1
      end if
      i = SDDS_GetParameterIndex_F(6,'Z')
      if (i .EQ. -1) then
         call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
         stop 1
      end if
      SDDSNPINZIndex = i
      i = SDDS_GetParameterType_F(6, SDDSNPINZIndex) 
      if (i .NE. SDDS_DOUBLE) then
         write (6,*) "invalid parameter type in particle file"
         stop 1
      end if
      i = SDDS_GetParameterIndex_F(6,'ParticleRecordsInZ')
      if (i .EQ. -1) then
         SDDSNPINPRIZIndex = -1
      else
         SDDSNPINPRIZIndex = i
         i = SDDS_GetParameterType_F(6, SDDSNPINPRIZIndex) 
         if (i .NE. SDDS_LONG) then
            write (6,*) "invalid parameter type in particle file"
            stop 1
         end if
      end if
      do j = 1,6
         i = SDDS_GetColumnIndex_F(6,cNamesD(j))
         if (i .EQ. -1) then
            call SDDS_PrintErrors_F(SDDS_VERBOSE_PrintErrors)
            stop 1
         end if
         SDDSNPINColumnIndex(j) = i
         i = SDDS_GetColumnType_F(6, SDDSNPINColumnIndex(j)) 
         if (i .NE. SDDS_DOUBLE) then
            write (6,*) "invalid column type in particle file"
            stop 1
         end if
      end do
      Return
      End
